package com.thebrokenrail.twine;

import com.thebrokenrail.twine.block.GlowingObsidianBlock;
import com.thebrokenrail.twine.item.BackpackItem;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.client.itemgroup.FabricItemGroupBuilder;
import net.fabricmc.fabric.api.container.ContainerProviderRegistry;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.screen.GenericContainerScreenHandler;
import net.minecraft.screen.ScreenHandlerType;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class Twine implements ModInitializer {
    public static final String NAMESPACE = "twine";

    public static final GlowingObsidianBlock GLOWING_OBSIDIAN = new GlowingObsidianBlock();

    public static final ItemGroup ITEM_GROUP = FabricItemGroupBuilder.build(new Identifier(NAMESPACE, "item_group"), () -> new ItemStack(GLOWING_OBSIDIAN));

    public static final Identifier BACKPACK_SCREEN = new Identifier(NAMESPACE, "backpack");
    public static final Item SMALL_BACKPACK = new BackpackItem(false);
    public static final Item LARGE_BACKPACK = new BackpackItem(true);

    public static final int STAGE_COUNT = 6;
    public static final int STAGE_TIME = 24000;

    @Override
    public void onInitialize() {
        ContainerProviderRegistry.INSTANCE.registerFactory(BACKPACK_SCREEN, (i, identifier, playerEntity, buf) -> {
            boolean large = buf.readBoolean();
            Hand hand = buf.readEnumConstant(Hand.class);
            int rows = large ? 6 : 3;
            ItemStack stack = playerEntity.getStackInHand(hand);
            return new GenericContainerScreenHandler(ScreenHandlerType.STONECUTTER, i, playerEntity.inventory, new BackpackItem.ItemInventory(9 * rows, stack, hand), rows);
        });
        Registry.register(Registry.ITEM, new Identifier(NAMESPACE, "small_backpack"), SMALL_BACKPACK);
        Registry.register(Registry.ITEM, new Identifier(NAMESPACE, "large_backpack"), LARGE_BACKPACK);

        Registry.register(Registry.BLOCK, new Identifier(NAMESPACE, "glowing_obsidian"), GLOWING_OBSIDIAN);
        Registry.register(Registry.ITEM, new Identifier(NAMESPACE, "glowing_obsidian"), new BlockItem(GLOWING_OBSIDIAN, new Item.Settings().group(ITEM_GROUP)));
    }
}
