package com.thebrokenrail.twine.block;

import net.minecraft.block.Block;
import net.minecraft.block.Material;
import net.minecraft.block.MaterialColor;
import net.minecraft.entity.AreaEffectCloudEntity;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.damage.DamageSource;
import net.minecraft.entity.mob.Monster;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class GlowingObsidianBlock extends Block {
    public GlowingObsidianBlock() {
        super(Settings.of(Material.STONE, MaterialColor.BLACK).requiresTool().strength(50.0F, 1200.0F).lightLevel(state -> 4));
    }

    @Override
    public void onSteppedOn(World world, BlockPos pos, Entity entity) {
        super.onSteppedOn(world, pos, entity);
        if (entity instanceof LivingEntity && entity.age % 5 == 0) {
            final float amount = 1f;
            if (entity instanceof Monster) {
                ((LivingEntity) entity).heal(amount);
            } else {
                entity.damage(DamageSource.MAGIC, amount);
            }
        }
    }
}
